Subject: Re: [RFC net-next 0/2] Introduce MDIO probe order C45 over C22

From: Wong Vee Khee <[email-masked]>
Date: Wed, 2 Jun 2021 07:03:52 +0800

On Wed, Jun 02, 2021 at 12:21:58AM +0200, Andrew Lunn wrote:
> On Tue, Jun 01, 2021 at 11:44:23PM +0800, Wong Vee Khee wrote:
> > On Tue, Jun 01, 2021 at 03:04:51PM +0200, Andrew Lunn wrote:
> > > On Tue, Jun 01, 2021 at 06:47:34PM +0800, Wong Vee Khee wrote:
> > > > On Tue, May 25, 2021 at 03:34:34PM +0200, Andrew Lunn wrote:
> > > > > On Tue, May 25, 2021 at 01:58:03PM +0800, Wong Vee Khee wrote:
> > > > > > Synopsys MAC controller is capable of pairing with external PHY devices
> > > > > > that accessible via Clause-22 and Clause-45.
> > > > > > 
> > > > > > There is a problem when it is paired with Marvell 88E2110 which returns
> > > > > > PHY ID of 0 using get_phy_c22_id(). We can add this check in that
> > > > > > function, but this will break swphy, as swphy_reg_reg() return 0. [1]
> > > > > 
> > > > > Is it possible to identify it is a Marvell PHY? Do any of the other
> > > > > C22 registers return anything unique? I'm wondering if adding
> > > > > .match_phy_device to genphy would work to identify it is a Marvell PHY
> > > > > and not bind to it. Or we can turn it around, make the
> > > > > .match_phy_device specifically look for the fixed-link device by
> > > > > putting a magic number in one of the vendor registers.
> > > > >
> > > > 
> > > > I checked the Marvell and did not see any unique register values.
> > > > Also, since get_phy_c22_id() returns a *phy_id== 0, it is not bind to
> > > > any PHY driver, so I don't think adding the match_phy_device check in
> > > > getphy would help.
> > > 
> > > It has a Marvell ID in C45 space. So maybe we need to special case for
> > > ID 0. If we get that, go look in C45 space. If we find a valid ID, use
> > > it. If we get EOPNOTSUP because the MDIO bus is not C45 capable, or we
> > > don't find a vendor ID in C45 space, keep with id == 0 and load
> > > genphy?
> > >
> > 
> > Make sense for me.
> > Let me what you think of adding the checks in *get_phy_device():
> > 
> > diff --git a/drivers/net/phy/phy_device.c b/drivers/net/phy/phy_device.c
> > index 1539ea021ac0..ad9a87fadea1 100644
> > --- a/drivers/net/phy/phy_device.c
> > +++ b/drivers/net/phy/phy_device.c
> > @@ -862,11 +862,21 @@ struct phy_device *get_phy_device(struct mii_bus *bus, int addr, bool is_c45)
> >         c45_ids.mmds_present = 0;
> >         memset(c45_ids.device_ids, 0xff, sizeof(c45_ids.device_ids));
> > 
> > -       if (is_c45)
> > +       if (is_c45) {
> >                 r = get_phy_c45_ids(bus, addr, &c45_ids);
> > -       else
> > +       } else {
> >                 r = get_phy_c22_id(bus, addr, &phy_id);
> > 
> > +               if (phy_id == 0) {
> > +                       r = get_phy_c45_ids(bus, addr, &c45_ids);
> > +                       if (r == -ENOTSUPP || r == -ENODEV)
> > +                               return 0;
> 
> This bit is not correct. I said 'or we don't find a vendor ID in C45
> space, keep with id == 0'. We need to keep backwards compatibility. If
> get_phy_c22_id() did not return an error we should create a device
> with phy_id 0, if get_phy_c45_ids() returns an error.
>

Yeah, you're right. Thanks for pointing that out. It should be:

diff --git a/drivers/net/phy/phy_device.c b/drivers/net/phy/phy_device.c
index 1539ea021ac0..73bfde770f2d 100644
--- a/drivers/net/phy/phy_device.c
+++ b/drivers/net/phy/phy_device.c
@@ -862,11 +862,22 @@ struct phy_device *get_phy_device(struct mii_bus *bus, int addr, bool is_c45)
        c45_ids.mmds_present = 0;
        memset(c45_ids.device_ids, 0xff, sizeof(c45_ids.device_ids));

-       if (is_c45)
+       if (is_c45) {
                r = get_phy_c45_ids(bus, addr, &c45_ids);
-       else
+       } else {
                r = get_phy_c22_id(bus, addr, &phy_id);

+               if (phy_id == 0) {
+                       r = get_phy_c45_ids(bus, addr, &c45_ids);
+                       if (r == -ENOTSUPP || r == -ENODEV)
+                               return phy_device_create(bus, addr, phy_id,
+                                                        false, &c45_ids);
+                       else
+                               return phy_device_create(bus, addr, phy_id,
+                                                        true, &c45_ids);
+               }
+       }
+
        if (r)
                return ERR_PTR(r);

VK